Loading...
Searching...
No Matches
websocketpp::transport::asio::basic_socket::connection Class Reference

Basic Asio connection socket component. More...

`#include <none.hpp>`

Inheritance diagram for websocketpp::transport::asio::basic_socket::connection:

## Public Types

typedef connection | type
| Type of this connection socket component.
typedef lib::shared_ptr< type > | ptr
| Type of a shared pointer to this connection socket component.
typedef lib::asio::io_context * | io_context_ptr
| Type of a pointer to the Asio io_context being used.
typedef lib::shared_ptr< lib::asio::io_context::strand > | strand_ptr
| Type of a pointer to the Asio io_context strand being used.
typedef lib::asio::ip::tcp::socket | socket_type
| Type of the ASIO socket being used.
typedef lib::shared_ptr< socket_type > | socket_ptr
| Type of a shared pointer to the socket being used.

## Public Member Functions

ptr | get_shared ()
| Get a shared pointer to this component.
bool | is_secure () const
| Check whether or not this connection is secure.
void | set_socket_init_handler (socket_init_handler h)
| Set the socket initialization handler.
lib::asio::ip::tcp::socket & | get_socket ()
| Retrieve a pointer to the underlying socket.
lib::asio::ip::tcp::socket & | get_next_layer ()
| Retrieve a pointer to the underlying socket.
lib::asio::ip::tcp::socket & | get_raw_socket ()
| Retrieve a pointer to the underlying socket.
std::string | get_remote_endpoint (lib::error_code &ec) const
| Get the remote endpoint address.

## Static Public Member Functions

template<typename ErrorCodeType>
static lib::error_code | translate_ec (ErrorCodeType)
| Translate any security policy specific information about an error code.
static lib::error_code | translate_ec (lib::error_code ec)

## Protected Member Functions

lib::error_code | init_asio (io_context_ptr context, strand_ptr, bool)
| Perform one time initializations.
void | set_uri (uri_ptr)
| Set uri hook.
void | pre_init (init_handler callback)
| Pre-initialize security policy.
void | post_init (init_handler callback)
| Post-initialize security policy.
void | set_handle (connection_hdl hdl)
| Sets the connection handle.
lib::asio::error_code | cancel_socket ()
| Cancel all async operations on this socket.
void | async_shutdown (socket::shutdown_handler h)
lib::error_code | get_ec () const

## Detailed Description

Basic Asio connection socket component.

transport::asio::basic_socket::connection implements a connection socket component using Asio ip::tcp::socket.

Definition at line 58 of file none.hpp.

## Member Typedef Documentation

## io_context_ptr

typedef lib::asio::io_context* websocketpp::transport::asio::basic_socket::connection::io_context_ptr

Type of a pointer to the Asio io_context being used.

Definition at line 66 of file none.hpp.

## ptr

typedef lib::shared_ptr<type> websocketpp::transport::asio::basic_socket::connection::ptr

Type of a shared pointer to this connection socket component.

Definition at line 63 of file none.hpp.

## socket_ptr

typedef lib::shared_ptr<socket_type> websocketpp::transport::asio::basic_socket::connection::socket_ptr

Type of a shared pointer to the socket being used.

Definition at line 72 of file none.hpp.

## socket_type

typedef lib::asio::ip::tcp::socket websocketpp::transport::asio::basic_socket::connection::socket_type

Type of the ASIO socket being used.

Definition at line 70 of file none.hpp.

## strand_ptr

typedef lib::shared_ptr<lib::asio::io_context::strand> websocketpp::transport::asio::basic_socket::connection::strand_ptr

Type of a pointer to the Asio io_context strand being used.

Definition at line 68 of file none.hpp.

## type

typedef connection websocketpp::transport::asio::basic_socket::connection::type

Type of this connection socket component.

Definition at line 61 of file none.hpp.

## Constructor & Destructor Documentation

## connection()

websocketpp::transport::asio::basic_socket::connection::connection | ( |  | ) |

inline explicit

Definition at line 74 of file none.hpp.

## Member Function Documentation

## async_shutdown()

void websocketpp::transport::asio::basic_socket::connection::async_shutdown | ( | socket::shutdown_handler | h | ) |

inline protected

Definition at line 254 of file none.hpp.

## cancel_socket()

lib::asio::error_code websocketpp::transport::asio::basic_socket::connection::cancel_socket | ( |  | ) |

inline protected

Cancel all async operations on this socket.

Attempts to cancel all async operations on this socket and reports any failures.

NOTE: Windows XP and earlier do not support socket cancellation.

Returns
  The error that occurred, if any.

Definition at line 248 of file none.hpp.

## get_ec()

lib::error_code websocketpp::transport::asio::basic_socket::connection::get_ec | ( |  | ) | const

inline protected

Definition at line 260 of file none.hpp.

## get_next_layer()

lib::asio::ip::tcp::socket & websocketpp::transport::asio::basic_socket::connection::get_next_layer | ( |  | ) |

inline

Retrieve a pointer to the underlying socket.

This is used internally.

Definition at line 116 of file none.hpp.

## get_raw_socket()

lib::asio::ip::tcp::socket & websocketpp::transport::asio::basic_socket::connection::get_raw_socket | ( |  | ) |

inline

Retrieve a pointer to the underlying socket.

This is used internally. It can also be used to set socket options, etc

Definition at line 124 of file none.hpp.

## get_remote_endpoint()

std::string websocketpp::transport::asio::basic_socket::connection::get_remote_endpoint | ( | lib::error_code & | ec | ) | const

inline

Get the remote endpoint address.

The iostream transport has no information about the ultimate remote endpoint. It will return the string "iostream transport". To indicate this.

TODO: allow user settable remote endpoint addresses if this seems useful

Returns
  A string identifying the address of the remote endpoint

Definition at line 138 of file none.hpp.

## get_shared()

ptr websocketpp::transport::asio::basic_socket::connection::get_shared | ( |  | ) |

inline

Get a shared pointer to this component.

Definition at line 80 of file none.hpp.

## get_socket()

lib::asio::ip::tcp::socket & websocketpp::transport::asio::basic_socket::connection::get_socket | ( |  | ) |

inline

Retrieve a pointer to the underlying socket.

This is used internally. It can also be used to set socket options, etc

Definition at line 108 of file none.hpp.

## init_asio()

lib::error_code websocketpp::transport::asio::basic_socket::connection::init_asio | ( | io_context_ptr | context,
|  | strand_ptr | ,
|  | bool | )

inline protected

Perform one time initializations.

init_asio is called once immediately after construction to initialize Asio components to the io_context. At this stage the connection is speculative, the server may not have actually received a new connection.

Parameters

  context | A pointer to the endpoint's io_context
  strand | A shared pointer to the connection's asio strand
  is_server | Whether or not the endpoint is a server or not.

Definition at line 166 of file none.hpp.

## is_secure()

bool websocketpp::transport::asio::basic_socket::connection::is_secure | ( |  | ) | const

inline

Check whether or not this connection is secure.

Returns
  Whether or not this connection is secure

Definition at line 88 of file none.hpp.

## post_init()

void websocketpp::transport::asio::basic_socket::connection::post_init | ( | init_handler | callback | ) |

inline protected

Post-initialize security policy.

Called by the transport after all intermediate proxies have been negotiated. This gives the security policy the chance to talk with the real remote endpoint for a bit before the websocket handshake.

Parameters

  callback | Handler to call back with completion information

Definition at line 224 of file none.hpp.

## pre_init()

void websocketpp::transport::asio::basic_socket::connection::pre_init | ( | init_handler | callback | ) |

inline protected

Pre-initialize security policy.

Called by the transport after a new connection is accepted to initialize the socket component of the connection. This method is not allowed to write any bytes to the wire. This initialization happens before any proxies or other intermediate wrappers are negotiated.

Parameters

  callback | Handler to call back with completion information

Definition at line 201 of file none.hpp.

## set_handle()

void websocketpp::transport::asio::basic_socket::connection::set_handle | ( | connection_hdl | hdl | ) |

inline protected

Sets the connection handle.

The connection handle is passed to any handlers to identify the connection

Parameters

  hdl | The new handle

Definition at line 235 of file none.hpp.

## set_socket_init_handler()

void websocketpp::transport::asio::basic_socket::connection::set_socket_init_handler | ( | socket_init_handler | h | ) |

inline

Set the socket initialization handler.

The socket initialization handler is called after the socket object is created but before it is used. This gives the application a chance to set any Asio socket options it needs.

Parameters

  h | The new socket_init_handler

Definition at line 100 of file none.hpp.

## set_uri()

void websocketpp::transport::asio::basic_socket::connection::set_uri | ( | uri_ptr |  | ) |

inline protected

Set uri hook.

Called by the transport as a connection is being established to provide the uri being connected to to the security/socket layer.

This socket policy doesn't use the uri so it is ignored.

Since
  0.6.0

Parameters

  u | The uri to set

Definition at line 190 of file none.hpp.

## translate_ec() [1/2]

template<typename ErrorCodeType>

lib::error_code websocketpp::transport::asio::basic_socket::connection::translate_ec | ( | ErrorCodeType |  | ) |

inline static

Translate any security policy specific information about an error code.

Translate_ec takes an Asio error code and attempts to convert its value to an appropriate websocketpp error code. In the case that the Asio and Websocketpp error types are the same (such as using boost::asio and boost::system_error or using standalone asio and std::system_error the code will be passed through natively.

In the case of a mismatch (boost::asio with std::system_error) a translated code will be returned. The plain socket policy does not have any additional information so all such errors will be reported as the generic transport pass_through error.

Since
  0.3.0

Parameters

  ec | The error code to translate_ec

Returns
  The translated error code

Definition at line 285 of file none.hpp.

## translate_ec() [2/2]

lib::error_code websocketpp::transport::asio::basic_socket::connection::translate_ec | ( | lib::error_code | ec | ) |

inline static

Overload of translate_ec to catch cases where lib::error_code is the same type as lib::asio::error_code

Definition at line 293 of file none.hpp.

The documentation for this class was generated from the following file:

- websocketpp/transport/asio/security/none.hpp